<?php
define('ADM_RUSEO_PAGE', 'load.php?id=ruSEO');

add_action('support-sidebar', 'createSideMenu', array(basename(__FILE__, ".php"), 'ruSEO'));
add_action('index-pretemplate', 'ruSEO', array());

register_plugin(
	basename(__FILE__, ".php"),
	'ruSEO',
	'0.3.1',
	'opiums',
	'http://opiums.eu',
	'SEO инструменты для GetSimple. Для конфигурирования перейдите в <a href="'.ADM_RUSEO_PAGE.'">Настройки</a>.',
	'support',
	'ruSEO_info'
);

class ruseo{
	// Убираем index.php
	public static function noindexphp(){
		$r_uri = $_SERVER['REQUEST_URI'];
		if(!empty($r_uri) && strpos($r_uri, 'index.php')){
			$uri = preg_replace('/index\.php/', '', $r_uri);
			if($r_uri != $uri){
				header('Location: '.$uri, true, 301);
				exit();
			}
		}
	}

	// Убираем слеш в конце ссылок
	public static function noshash(){
		$r_uri = $_SERVER['REQUEST_URI'];
		if(!empty($r_uri) && strlen($r_uri) > 1){
			$uri = rtrim($r_uri, '/');
			if($r_uri != $uri){
				header('Location: '.$uri, true, 301);
				exit();
			}
		}
	}
	
	// Убираем дубликаты в строке URL
	public static function nodublicate(){
		$r_uri = $_SERVER['REQUEST_URI'];
		$p_uri = parse_url($r_uri);
		if(!empty($p_uri['path']) && strlen($p_uri['path']) > 1){ // для ЧПУ
			$url = explode('/', $p_uri['path']);
			if(!empty($url[0]) && !empty($url[1]) && $url[0] == $url[1]){
				header('Location: /'.$url[1]);
				exit();
			}
			if(!empty($url[1]) && !empty($url[2]) && $url[1] == $url[2]){
				header('Location: /'.$url[2], true, 301);
				exit();
			}
			if(!empty($url[2]) && !empty($url[3]) && $url[2] == $url[3]){
				header('Location: /'.$url[3], true, 301);
				exit();
			}
		}elseif(!empty($p_uri['query']) && strlen($p_uri['query']) > 1){ // для GET
			$url = preg_replace(array('/id=/', '/& /'), ' ', $p_uri['query']);
			$url = explode(' ', $url);
			if(!empty($url[0]) && !empty($url[1]) && $url[0] == $url[1]){
				header('Location: /?id='.$url[1]);
				exit();
			}
			if(!empty($url[1]) && !empty($url[2]) && $url[1] == $url[2]){
				header('Location: /?id='.$url[2], true, 301);
				exit();
			}
			if(!empty($url[2]) && !empty($url[3]) && $url[2] == $url[3]){
				header('Location: /?id='.$url[3], true, 301);
				exit();
			}
		}
	}
	
	// Провера корректности вхождения URL
	public static function checkurl($cont){
		global $file_404, $user_created_404, $pagesArray;
		global $title, $date, $metak, $metad, $url, $content, $parent, $template_file, $private;
		$slugexc = (strripos($cont[0], ",") != false) ? explode(",", $cont[0]) : array('poisk', 'search', 'otzyvy', 'reviews', 'shop');
		if(in_array((string)$url, $slugexc)) return;
		$getexc = (strripos($cont[1], ",") != false) ? explode(",", $cont[1]) : array('setlang');
		$getres = true;
		foreach(array_keys($_GET) as $get){
			if(in_array($get, $getexc)){
				$getres = false; break;
			}
		}
		//$diff = array_diff($getexc, array_keys($_GET));
		if(!$getres) return;
		$site_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http")."://".$_SERVER['HTTP_HOST'];
		$nowurl = $site_url.$_SERVER['REQUEST_URI'];
		$requrl = find_url($url, $parent);
		if($requrl != $nowurl){
			if(isset($pagesArray['404'])){
				$data_index = getXml($user_created_404);		
			}elseif(file_exists($file_404)){
				$data_index = getXml($file_404);
			}else{
				die(header($_SERVER["SERVER_PROTOCOL"]." 404 Not Found"));
			}
			header($_SERVER["SERVER_PROTOCOL"]." 404 Not Found");
			$title         = $data_index->title;
			$date          = $data_index->pubDate;
			$metak         = $data_index->meta;
			$metad         = $data_index->metad;
			$url           = $data_index->url;
			$content       = $data_index->content;
			$parent        = $data_index->parent;
			$template_file = $data_index->template;
			$private       = $data_index->private;			
		}
	}
	
	// 301 редирект page1 => page2/n
	public static function redirect($cont){
		$r_uri = $_SERVER['REQUEST_URI'];
		$contain = explode(PHP_EOL, $cont);
		foreach($contain as $row){
			if(!empty($r_uri) && !empty(trim($row))){
				preg_match('/(.*)=>(.*)/', $row, $tar);
				unset($tar[0]);
				if($r_uri == trim($tar[1])){
					//print_r($tar); //debug
					header('Location: '.trim($tar[2]), true, 301);
					exit();
				}
			}
		}
	}
}

function ruSEO(){
	if(file_exists(GSDATAOTHERPATH.'ruseo_conf.php')){
		include(GSDATAOTHERPATH.'ruseo_conf.php');
		if(!empty($ruseo_cf['noshash']) && $ruseo_cf['noshash'] == 'yes') ruseo::noshash();
		if(!empty($ruseo_cf['noindexphp']) && $ruseo_cf['noindexphp'] == 'yes') ruseo::noindexphp();
		if(!empty($ruseo_cf['nodublicate']) && $ruseo_cf['nodublicate'] == 'yes') ruseo::nodublicate();
		if(!empty($ruseo_cf['checkurl']) && $ruseo_cf['checkurl'] == 'yes' && strlen($ruseo_cf['slugexc']) > 1)
			ruseo::checkurl(array($ruseo_cf['slugexc'], $ruseo_cf['getexc']));
		if(!empty($ruseo_cf['redirect']) && strlen($ruseo_cf['redirect']) > 1) ruseo::redirect($ruseo_cf['redirect']);
	}
}

function ruSEO_info(){
	if(!file_exists(GSDATAOTHERPATH.'ruseo_conf.php')){
		$ruseo_cf = array(
			"noshash" => "yes",
			"noindexphp" => "yes",
			"nodublicate" => "yes",
			"checkurl" => "yes",
			"slugexc" => "poisk,search,otzyvy,reviews,shop",
			"getexc" => "setlang,utm_source,utm_medium,utm_campaign,utm_content,utm_term",
			"redirect" => "/ruSEO_page1 => /ruSEO_page2".PHP_EOL."/ruSEO_page3 => /ruSEO_page4".PHP_EOL,
		);
		$ruseo_save_cnf = '<?php'.PHP_EOL.'$ruseo_cf = '.var_export($ruseo_cf, true).';'.PHP_EOL.'?>';
		file_put_contents(GSDATAOTHERPATH.'ruseo_conf.php', $ruseo_save_cnf);
		echo '<div class="updated">Файл конфигурации создан! Вернитесь <a href="'.ADM_RUSEO_PAGE.'">назад</a></div>';
		exit();
	}
	if(isset($_POST['ruseo_conf'])){
		include(GSDATAOTHERPATH.'ruseo_conf.php');
		$ruseo_cf = array(
			"noshash" => (isset($_POST['noshash']) && $_POST['noshash'] == "on") ? 'yes' : 'no',
			"noindexphp" => (isset($_POST['noindexphp']) && $_POST['noindexphp'] == "on") ? 'yes' : 'no',
			"nodublicate" => (isset($_POST['nodublicate']) && $_POST['nodublicate'] == "on") ? 'yes' : 'no',
			"checkurl" => (isset($_POST['checkurl']) && $_POST['checkurl'] == "on") ? 'yes' : 'no',
			"slugexc" => (isset($_POST['slugexc'])) ? $_POST['slugexc'] : $ruseo_cf['slugexc'],
			"getexc" => (isset($_POST['getexc'])) ? $_POST['getexc'] : $ruseo_cf['getexc'],
			"redirect" => (isset($_POST['redirect'])) ? $_POST['redirect'] : $ruseo_cf['redirect'],
		);
		$ruseo_save_cnf = '<?php'.PHP_EOL.'$ruseo_cf = '.var_export($ruseo_cf, true).';'.PHP_EOL.'?>';
		file_put_contents(GSDATAOTHERPATH.'ruseo_conf.php', $ruseo_save_cnf);
		echo '<div class="updated">Файл конфигурации заменен! Вернитесь <a href="'.ADM_RUSEO_PAGE.'">назад</a></div>';
	}else{
		include(GSDATAOTHERPATH.'ruseo_conf.php');
		$ruseo_noshash = ($ruseo_cf['noshash'] == 'yes') ? 'checked' : '';
		$ruseo_noindexphp = ($ruseo_cf['noindexphp'] == 'yes') ? 'checked' : '';
		$ruseo_nodublicate = ($ruseo_cf['nodublicate'] == 'yes') ? 'checked' : '';
		$ruseo_checkurl = ($ruseo_cf['checkurl'] == 'yes') ? 'checked' : '';
		$ruseo_slugexc = (!empty($ruseo_cf['slugexc'])) ? $ruseo_cf['slugexc'] : '';
		$ruseo_getexc = (!empty($ruseo_cf['getexc'])) ? $ruseo_cf['getexc'] : '';
		$ruseo_redirect = (!empty($ruseo_cf['redirect'])) ? $ruseo_cf['redirect'] : '';
		?>
		<div id="ruSEO">
			<h3>ruSEO</h3>
			<p>
				<form action="<?=ADM_RUSEO_PAGE?>" method="post">
					<table>
					<input type="hidden" name="ruseo_conf" value="new_conf" style="display:none;" />
					<tr><td>Удалять слэш в конце URL (<b>/page/ => /page</b>)</td><td><input type="checkbox" name="noshash" <?=$ruseo_noshash?> /></td><tr>
					<tr><td>Удалять из строки URL <b>index.php</b></td><td><input type="checkbox" name="noindexphp" <?=$ruseo_noindexphp?> /></td><tr>
					<tr><td>Удалять дубликаты из строки URL (<b>/page/page/ => /page</b>)</td><td><input type="checkbox" name="nodublicate" <?=$ruseo_nodublicate?> /></td><tr>
					<tr><td>Проверять корректность URL (ниже <b>slug</b> исключения страниц через запятую)</td><td><input type="checkbox" name="checkurl" <?=$ruseo_checkurl?> /></td><tr>
					<tr><td colspan="2"><textarea name="slugexc" style="width:100%;height:100px;"><?=$ruseo_slugexc?></textarea></td><tr>
					<tr><td colspan="2">Исключения <b>GET</b> запросов:<br><textarea name="getexc" style="width:100%;height:100px;"><?=$ruseo_getexc?></textarea></td><tr>
					<tr><td colspan="2">Редиректы для перенаправления страниц (301), каждый редирект с новой строки.<br />Пример: <b>/page1 => /page2 \n</b><br /><textarea name="redirect" style="width:100%;height:100px;"><?=$ruseo_redirect?></textarea></td><tr>
					<tr><td></td><td><input type="submit" value="Сохранить" /></td><tr>
					</table>
				</form>
			</p>
		</div>
		<?php
	}
}
?>